HDU 6205 card【单调队列思想+暴力】

HDU 6205

card card card

Time Limit: 8000/4000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 0    Accepted Submission(s): 0


Problem Description
As a fan of Doudizhu, WYJ likes collecting playing cards very much.
One day, MJF takes a stack of cards and talks to him: let's play a game and if you win, you can get all these cards. MJF randomly assigns these cards into n heaps, arranges in a row, and sets a value on each heap, which is called "penalty value".
Before the game starts, WYJ can move the foremost heap to the end any times.
After that, WYJ takes the heap of cards one by one, each time he needs to move all cards of the current heap to his hands and face them up, then he turns over some cards and the number of cards he turned is equal to the penaltyvalue .
If at one moment, the number of cards he holds which are face-up is less than the penaltyvalue , then the game ends. And WYJ can get all the cards in his hands (both face-up and face-down).
Your task is to help WYJ maximize the number of cards he can get in the end.So he needs to decide how many heaps that he should move to the end before the game starts. Can you help him find the answer?
MJF also guarantees that the sum of all "penalty value" is exactly equal to the number of all cards.
 

Input
There are about 10 test cases ending up with EOF.
For each test case:
the first line is an integer n ( 1n106 ), denoting n heaps of cards;
next line contains n integers, the i th integer ai ( 0ai1000 ) denoting there are ai cards in i th heap;
then the third line also contains n integers, the i th integer bi ( 1bi1000 ) denoting the "penalty value" of i th heap is bi .
 

Output
For each test case, print only an integer, denoting the number of piles WYJ needs to move before the game starts. If there are multiple solutions, print the smallest one.
 

Sample Input
  
  
5 4 6 2 8 4 1 5 7 9 2
 
Sample Output
  
  
4


//菜鸡的个人笔记,没有题解
思路:将权值数组扩充两倍,记录前缀和,然后找到一个利用单调队列思想,维持一个单调递减队列,由于这里只用求出拿到最多牌的移动次数,只用维持长度为二的单调递减数列,所以直接暴力将前缀数组扫一遍,就OK啦。
ACcode
#include<iostream>
#include<cstdio>
#include<cstring>
#include<vector>
#include<algorithm>
using namespace std;
typedef long long  LL;
const int INF=0x3f3f3f3f;
const int N=1000005;
int a[N],s[N*2],ans,mixx,n,x;
 void scan_d(int &ret)
{
    char c;
    ret = 0;
    while ((c = getchar()) < '0' || c > '9');
    while (c >= '0' && c <= '9')
    {
        ret = ret * 10 + (c - '0'), c = getchar();
    }
}
int main()
{
    while(scanf("%d",&n)!=EOF)
    {
        for(int i=1;i<=n;i++)scan_d(a[i]);
        for(int i=1;i<=n;i++)
        {
            scan_d(x);
            a[i]-=x;
            s[i]=s[i-1]+a[i];
        }
        for(int i=n+1;i<=n+n;i++)
            s[i]=s[i-1]+a[i-n];
            s[n+n+1]=-INF;
         int l=0;
         mixx=-1;
         for(int i=1;i<=n*2+1;i++)
         {
             if(s[i]<s[l])
             {
                 int v=i-l-1;
                 if(v>n)v=n;
                 if(v>mixx)
                 {
                     mixx=v;
                     ans=l;
                 }
                 l=i;
             }
         }
         printf("%d\n",ans);
    }
    return 0;
}





  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值